#!/usr/bin/env python
#-!- coding: utf-8 -!-

import os
import sys
import commands
import urllib
import re

UA = "User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:2.0.1) Gecko/20100101 Firefox/4.0.1"
counter = 1

def build_post_data(data):
	outdata = "";
	for k in data.keys():
		postvar = "%s=%s" % (urllib.quote(k, safe=""), urllib.quote(data[k], safe=""))
		if (outdata != ""):
			outdata = "%s&%s" % (outdata, postvar)
		else:
			outdata = postvar
	return outdata

def get_page(url, referer = "", postData = None):
	global counter, wget_template

	if postData:
		wget = "%s --referer \"%s\" --post-data=\"%s\"" % ((wget_template % (url)), referer, build_post_data(postData))
	else:
		wget = "%s --referer \"%s\"" % ((wget_template % url), referer)

	out = commands.getoutput(wget)
	return out

def build_wget_template(login):
	global wget_template
	try:
		os.remove("/tmp/tzones_cookie_%s.tmp" % login)
	except OSError:
		pass
	wget_template = "wget --load-cookies /tmp/tzones_cookie_%s.tmp --save-cookies /tmp/tzones_cookie_%s.tmp --keep-session-cookies --user-agent=\"%s\" --no-check-certificate \"%%s\" -O - -q" % (urllib.quote(login, safe="").replace("%", "%%"), urllib.quote(login, safe="").replace("%", "%%"), UA)

def sms(login, password, number, message, bail = False, toDisplayOnly = False):
	build_wget_template(login)

	login_url = "https://www.t-mobile.cz/.gang/login/tzones"
	logout_url = "https://www.t-mobile.cz/.gang/logout/tzones"
	sms1_url = "https://sms.client.tmo.cz/"
	sms2_url = "https://sms.client.tmo.cz/closed.jsp"

	get_page(login_url)
	logged = get_page(login_url, postData = {
			"username": login,
			"password": password
		})

	get_page(sms1_url)

	counter = get_page(sms2_url)
	counter = re.search("<input type=\"hidden\" name=\"counter\" value=\"(.*?)\" />", counter)

	mtype = "0"
	if toDisplayOnly:
		mtype = "1"

	if counter:
		postData = {
			"counter": counter.group(1),
			"submit": "Send",
			"type": "0",
			"mtype": mtype, #0 - SMS, 1 - SMS na display
			"confirmation": "0",
			"text": message[:750], #150 chars per SMS and max. 5 SMS = 750
			"recipients": number
		}
		sent = get_page(sms2_url, postData = postData)

		try:
			os.remove("/tmp/tzones_cookie_%s.tmp" % login)
		except OSError:
			pass

		if re.search("SMS zpr(.*?)v[ay] byl[ay] odesl(.*?)n[ay]", sent):
			return True, ""
		else:
			error = re.search("<p class=\"text-red text-size-2\">(.*?)<", sent, re.DOTALL)
			if error:
				return False, "SMS was not sent: %s" % unicode(error.group(1), "utf-8")
			else:
				#print "SMS was not sent. Blocked?"
				return False, "SMS was not send. Unknown reason."
	else:
		try:
			os.remove("/tmp/tzones_cookie_%s.tmp" % login)
		except OSError:
			pass

		return False, "Unable to find counter in the page. Login failed?"

if __name__ == "__main__":
	if len(sys.argv) > 4:
		if sms(sys.argv[1], sys.argv[2], sys.argv[3], " ".join(sys.argv[4:]))[0]:
			sys.exit(0)
		else:
			sys.exit(1)
	else:
		print "Usage: ./tzones.py <login> <password> <number> <text>"
		sys.exit(2)
